Index: tests/Tesselations/heptan/1.5/NonConvexEnvelope-heptan.dat
===================================================================
--- tests/Tesselations/heptan/1.5/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
+++ tests/Tesselations/heptan/1.5/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
@@ -0,0 +1,91 @@
+TITLE = "3D CONVEX SHELL"
+VARIABLES = "X" "Y" "Z" "U"
+ZONE T="heptan", N=23, E=64, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
+-7.27e-07 -1.22006 0.930455 3
+-7.27e-07 -1.22006 -0.849545 3
+-1.2492 0.921941 0.930455 3
+-1.2492 0.921941 -0.849545 3
+1.2492 0.921941 -0.849545 3
+1.2492 0.921941 0.930455 3
+-2.4985 -1.22006 -0.849545 4
+-2.4985 -1.22006 0.930455 4
+2.4985 -1.22006 0.930455 4
+2.4985 -1.22006 -0.849545 4
+-4.6377 -0.336759 0.0404545 6
+-3.7477 0.921941 0.930455 5
+-3.7477 0.921941 -0.849545 5
+4.6377 -0.336759 0.0404545 4
+3.7477 0.921941 -0.849545 4
+3.7477 0.921941 0.930455 4
+-7.27e-07 -0.590759 0.0404545 6
+-1.2492 0.292641 0.0404545 6
+1.2492 0.292641 0.0404545 6
+-2.4985 -0.590759 0.0404545 6
+2.4985 -0.590759 0.0404545 6
+-3.7477 0.292641 0.0404545 12
+3.7477 0.292641 0.0404545 12
+
+14 15 23
+14 15 23
+10 14 23
+10 15 23
+15 16 23
+15 16 23
+15 19 23
+5 15 19
+5 6 19
+5 6 19
+5 18 19
+4 5 18
+3 4 18
+3 4 18
+3 18 19
+3 6 19
+4 18 22
+4 13 22
+3 18 22
+3 12 22
+12 13 22
+12 13 22
+16 19 23
+6 16 19
+14 16 23
+14 16 23
+9 14 23
+9 16 23
+11 13 22
+11 13 22
+7 11 22
+7 13 22
+11 12 22
+11 12 22
+8 11 22
+8 12 22
+4 7 13
+2 4 7
+2 4 5
+2 5 10
+5 10 15
+3 8 12
+1 3 8
+1 3 6
+1 6 9
+6 9 16
+10 14 21
+9 10 21
+9 10 21
+9 14 21
+10 17 21
+2 10 17
+1 2 17
+1 2 17
+1 17 21
+1 9 21
+2 17 20
+2 7 20
+1 17 20
+1 8 20
+7 8 20
+7 8 20
+7 11 20
+8 11 20
Index: tests/Tesselations/heptan/2.5/NonConvexEnvelope-heptan.dat
===================================================================
--- tests/Tesselations/heptan/2.5/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
+++ tests/Tesselations/heptan/2.5/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
@@ -0,0 +1,48 @@
+TITLE = "3D CONVEX SHELL"
+VARIABLES = "X" "Y" "Z" "U"
+ZONE T="heptan", N=16, E=28, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
+-7.27e-07 -1.22006 0.930455 0
+-7.27e-07 -1.22006 -0.849545 0
+-1.2492 0.921941 0.930455 0
+-1.2492 0.921941 -0.849545 0
+1.2492 0.921941 -0.849545 0
+1.2492 0.921941 0.930455 0
+-2.4985 -1.22006 -0.849545 0
+-2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 -0.849545 0
+-4.6377 -0.336759 0.0404545 0
+-3.7477 0.921941 0.930455 0
+-3.7477 0.921941 -0.849545 0
+4.6377 -0.336759 0.0404545 0
+3.7477 0.921941 -0.849545 0
+3.7477 0.921941 0.930455 0
+
+14 15 16
+6 15 16
+5 6 15
+3 5 6
+3 4 5
+3 4 13
+3 12 13
+11 12 13
+8 11 12
+3 8 12
+1 3 8
+1 3 6
+1 6 9
+6 9 16
+9 14 16
+9 10 14
+2 9 10
+1 2 9
+1 2 7
+1 7 8
+7 8 11
+10 14 15
+5 10 15
+2 5 10
+2 4 5
+2 4 7
+4 7 13
+7 11 13
Index: tests/Tesselations/heptan/2/NonConvexEnvelope-heptan.dat
===================================================================
--- tests/Tesselations/heptan/2/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
+++ tests/Tesselations/heptan/2/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
@@ -0,0 +1,48 @@
+TITLE = "3D CONVEX SHELL"
+VARIABLES = "X" "Y" "Z" "U"
+ZONE T="heptan", N=16, E=28, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
+-7.27e-07 -1.22006 0.930455 0
+-7.27e-07 -1.22006 -0.849545 0
+-1.2492 0.921941 0.930455 0
+-1.2492 0.921941 -0.849545 0
+1.2492 0.921941 -0.849545 0
+1.2492 0.921941 0.930455 0
+-2.4985 -1.22006 -0.849545 0
+-2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 -0.849545 0
+-4.6377 -0.336759 0.0404545 0
+-3.7477 0.921941 0.930455 0
+-3.7477 0.921941 -0.849545 0
+4.6377 -0.336759 0.0404545 0
+3.7477 0.921941 -0.849545 0
+3.7477 0.921941 0.930455 0
+
+14 15 16
+6 15 16
+5 6 15
+3 5 6
+3 4 5
+3 4 13
+3 12 13
+11 12 13
+8 11 12
+3 8 12
+1 3 8
+1 3 6
+1 6 9
+6 9 16
+9 14 16
+9 10 14
+2 9 10
+1 2 9
+1 2 7
+1 7 8
+7 8 11
+10 14 15
+5 10 15
+2 5 10
+2 4 5
+2 4 7
+4 7 13
+7 11 13
Index: tests/Tesselations/heptan/25/NonConvexEnvelope-heptan.dat
===================================================================
--- tests/Tesselations/heptan/25/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
+++ tests/Tesselations/heptan/25/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
@@ -0,0 +1,48 @@
+TITLE = "3D CONVEX SHELL"
+VARIABLES = "X" "Y" "Z" "U"
+ZONE T="heptan", N=16, E=28, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
+-7.27e-07 -1.22006 0.930455 0
+-7.27e-07 -1.22006 -0.849545 0
+-1.2492 0.921941 0.930455 0
+-1.2492 0.921941 -0.849545 0
+1.2492 0.921941 -0.849545 0
+1.2492 0.921941 0.930455 0
+-2.4985 -1.22006 -0.849545 0
+-2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 -0.849545 0
+-4.6377 -0.336759 0.0404545 0
+-3.7477 0.921941 0.930455 0
+-3.7477 0.921941 -0.849545 0
+4.6377 -0.336759 0.0404545 0
+3.7477 0.921941 -0.849545 0
+3.7477 0.921941 0.930455 0
+
+14 15 16
+6 15 16
+5 6 15
+3 5 6
+3 4 5
+3 4 13
+3 12 13
+11 12 13
+8 11 12
+3 8 12
+1 3 8
+1 3 6
+1 6 9
+6 9 16
+9 14 16
+9 10 14
+2 9 10
+1 2 9
+1 2 7
+1 7 8
+7 8 11
+10 14 15
+5 10 15
+2 5 10
+2 4 5
+2 4 7
+4 7 13
+7 11 13
Index: tests/Tesselations/heptan/3.5/NonConvexEnvelope-heptan.dat
===================================================================
--- tests/Tesselations/heptan/3.5/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
+++ tests/Tesselations/heptan/3.5/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
@@ -0,0 +1,48 @@
+TITLE = "3D CONVEX SHELL"
+VARIABLES = "X" "Y" "Z" "U"
+ZONE T="heptan", N=16, E=28, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
+-7.27e-07 -1.22006 0.930455 0
+-7.27e-07 -1.22006 -0.849545 0
+-1.2492 0.921941 0.930455 0
+-1.2492 0.921941 -0.849545 0
+1.2492 0.921941 -0.849545 0
+1.2492 0.921941 0.930455 0
+-2.4985 -1.22006 -0.849545 0
+-2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 -0.849545 0
+-4.6377 -0.336759 0.0404545 0
+-3.7477 0.921941 0.930455 0
+-3.7477 0.921941 -0.849545 0
+4.6377 -0.336759 0.0404545 0
+3.7477 0.921941 -0.849545 0
+3.7477 0.921941 0.930455 0
+
+14 15 16
+6 15 16
+5 6 15
+3 5 6
+3 4 5
+3 4 13
+3 12 13
+11 12 13
+8 11 12
+3 8 12
+1 3 8
+1 3 6
+1 6 9
+6 9 16
+9 14 16
+9 10 14
+2 9 10
+1 2 9
+1 2 7
+1 7 8
+7 8 11
+10 14 15
+5 10 15
+2 5 10
+2 4 5
+2 4 7
+4 7 13
+7 11 13
Index: tests/Tesselations/heptan/3/NonConvexEnvelope-heptan.dat
===================================================================
--- tests/Tesselations/heptan/3/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
+++ tests/Tesselations/heptan/3/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
@@ -0,0 +1,48 @@
+TITLE = "3D CONVEX SHELL"
+VARIABLES = "X" "Y" "Z" "U"
+ZONE T="heptan", N=16, E=28, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
+-7.27e-07 -1.22006 0.930455 0
+-7.27e-07 -1.22006 -0.849545 0
+-1.2492 0.921941 0.930455 0
+-1.2492 0.921941 -0.849545 0
+1.2492 0.921941 -0.849545 0
+1.2492 0.921941 0.930455 0
+-2.4985 -1.22006 -0.849545 0
+-2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 -0.849545 0
+-4.6377 -0.336759 0.0404545 0
+-3.7477 0.921941 0.930455 0
+-3.7477 0.921941 -0.849545 0
+4.6377 -0.336759 0.0404545 0
+3.7477 0.921941 -0.849545 0
+3.7477 0.921941 0.930455 0
+
+14 15 16
+6 15 16
+5 6 15
+3 5 6
+3 4 5
+3 4 13
+3 12 13
+11 12 13
+8 11 12
+3 8 12
+1 3 8
+1 3 6
+1 6 9
+6 9 16
+9 14 16
+9 10 14
+2 9 10
+1 2 9
+1 2 7
+1 7 8
+7 8 11
+10 14 15
+5 10 15
+2 5 10
+2 4 5
+2 4 7
+4 7 13
+7 11 13
Index: tests/Tesselations/heptan/4/NonConvexEnvelope-heptan.dat
===================================================================
--- tests/Tesselations/heptan/4/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
+++ tests/Tesselations/heptan/4/NonConvexEnvelope-heptan.dat	(revision 0c5eeb409cae578bdec87b091364dde4c8b6940e)
@@ -0,0 +1,48 @@
+TITLE = "3D CONVEX SHELL"
+VARIABLES = "X" "Y" "Z" "U"
+ZONE T="heptan", N=16, E=28, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
+-7.27e-07 -1.22006 0.930455 0
+-7.27e-07 -1.22006 -0.849545 0
+-1.2492 0.921941 0.930455 0
+-1.2492 0.921941 -0.849545 0
+1.2492 0.921941 -0.849545 0
+1.2492 0.921941 0.930455 0
+-2.4985 -1.22006 -0.849545 0
+-2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 0.930455 0
+2.4985 -1.22006 -0.849545 0
+-4.6377 -0.336759 0.0404545 0
+-3.7477 0.921941 0.930455 0
+-3.7477 0.921941 -0.849545 0
+4.6377 -0.336759 0.0404545 0
+3.7477 0.921941 -0.849545 0
+3.7477 0.921941 0.930455 0
+
+14 15 16
+6 15 16
+5 6 15
+3 5 6
+3 4 5
+3 4 13
+3 12 13
+11 12 13
+8 11 12
+3 8 12
+1 3 8
+1 3 6
+1 6 9
+6 9 16
+9 14 16
+9 10 14
+2 9 10
+1 2 9
+1 2 7
+1 7 8
+7 8 11
+10 14 15
+5 10 15
+2 5 10
+2 4 5
+2 4 7
+4 7 13
+7 11 13
Index: tests/Tesselations/heptan/NonConvexEnvelope-heptan.dat
===================================================================
--- tests/Tesselations/heptan/NonConvexEnvelope-heptan.dat	(revision 6a7f78c9ef6be7e9a26caa642d5bff5a83ae7493)
+++ 	(revision )
@@ -1,48 +1,0 @@
-TITLE = "3D CONVEX SHELL"
-VARIABLES = "X" "Y" "Z" "U"
-ZONE T="heptan", N=16, E=28, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
-9.6377 5 6.78 0
-9.6377 5 5 0
-8.3885 7.142 6.78 0
-8.3885 7.142 5 0
-10.8869 7.142 5 0
-10.8869 7.142 6.78 0
-7.1392 5 5 0
-7.1392 5 6.78 0
-12.1362 5 6.78 0
-12.1362 5 5 0
-5 5.8833 5.89 0
-5.89 7.142 6.78 0
-5.89 7.142 5 0
-14.2754 5.8833 5.89 0
-13.3854 7.142 5 0
-13.3854 7.142 6.78 0
-
-14 15 16
-6 15 16
-5 6 15
-9 14 16
-6 9 16
-3 5 6
-3 4 5
-5 10 15
-9 10 14
-1 6 9
-1 3 6
-3 4 13
-3 12 13
-2 4 5
-2 5 10
-10 14 15
-2 9 10
-1 2 9
-1 3 8
-4 7 13
-3 8 12
-11 12 13
-2 4 7
-1 2 7
-1 7 8
-7 11 13
-8 11 12
-7 8 11